Public Class CadAcessoPerfil
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    'Classes Utilizadas
    Public webforms As New webforms
    Public RotinasDll As New Rotinas
    Public dr As System.Data.SqlClient.SqlDataReader
    Public alertas As New Alerta
    Public ClientScripts As New ClientScripts
    Public menu As New menu
    Public Validacao As New Validate
    Public util As New Utilitario
    Public xmlfile As New xmlfile

    'Declaracao dos Botoes
    Public btnPesquisar As System.web.ui.webcontrols.Button
    Public btnIncluir As System.web.ui.webcontrols.Button
    Public btnExcluir As System.web.ui.webcontrols.Button
    Public btnAlterar As System.web.ui.webcontrols.Button
    Public btnSalvar As System.web.ui.webcontrols.Button
    Public btnCancelar As System.web.ui.webcontrols.Button

    'Menu    
    Public btnAcesso As System.web.ui.webcontrols.Button
    Public btnPerfil As System.web.ui.webcontrols.Button
    Public btnUsuario As System.web.ui.webcontrols.Button
    Protected WithEvents edtFlagIncAtu As System.Web.UI.HtmlControls.HtmlInputHidden
    Protected WithEvents lblstatus As System.Web.UI.WebControls.Label
    Protected WithEvents pnlCadastro As System.Web.UI.WebControls.Panel
    Protected WithEvents dgConsulta As System.Web.UI.WebControls.DataGrid
    Protected WithEvents PanelGrid As System.Web.UI.WebControls.Panel
    Protected WithEvents lnkDgConsulta As System.Web.UI.WebControls.LinkButton
    Protected WithEvents edtPerDescricao As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblPerDescricao As System.Web.UI.WebControls.Label
    Protected WithEvents edtPerCodigo As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblPerCodigo As System.Web.UI.WebControls.Label
    Protected WithEvents lblTitulo As System.Web.UI.WebControls.Label
    Protected WithEvents Hidden1 As System.Web.UI.HtmlControls.HtmlInputHidden

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region


    '------------------------------------------------------------------------
    '   LOAD DA PAGINA
    '------------------------------------------------------------------------
    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        If Not IsPostBack() Then
            botoesCadastro()
            HabilitaBotoes()
            DesabilitaCampos()
            dgConsulta.Visible = False
        End If
        ClientScripts.ConfirmarExclusao(btnExcluir, "CONFIRMA EXCLUSO DO REGISTRO ?")
    End Sub
#Region "VALIDACAO DOS BOTOES CONFORME PERMISSAO DO USUARIO"
    '------------------------------------------------------------------------
    '  VALIDACAO DOS BOTOES CONFORME PERMISSAO DO USUARIO
    '------------------------------------------------------------------------
    Public Function ConvertFlag(ByVal flag)
        If UCase(flag) = "F" Then
            Return False
        Else
            Return True
        End If
    End Function

    Public Function botoesCadastro()
        btnIncluir.Enabled = ConvertFlag(Mid(menu.GetBotoesCadastro, 1, 1))
        btnAlterar.Enabled = False
        btnExcluir.Enabled = False
        btnSalvar.Enabled = False
        btnCancelar.Enabled = False
        btnPesquisar.Enabled = False 'ConvertFlag(Mid(menu.GetBotoesCadastro, 7, 1))
    End Function
    Public Function BotoesErro()
        btnIncluir.Enabled = False
        btnAlterar.Enabled = False
        btnExcluir.Enabled = False
        btnSalvar.Enabled = False
        btnCancelar.Enabled = False
        btnPesquisar.Enabled = False
    End Function
    Public Function BotoesAlterar()
        btnIncluir.Enabled = False
        btnAlterar.Enabled = False
        btnExcluir.Enabled = False
        btnSalvar.Enabled = False
        btnCancelar.Enabled = False
        btnPesquisar.Enabled = False
    End Function
    Public Function BotoesMostrar()
        btnIncluir.Enabled = ConvertFlag(Mid(menu.GetBotoesMostrar, 1, 1))
        btnAlterar.Enabled = ConvertFlag(Mid(menu.GetBotoesMostrar, 2, 1))
        btnExcluir.Enabled = ConvertFlag(Mid(menu.GetBotoesMostrar, 3, 1))
        btnSalvar.Enabled = False
        btnCancelar.Enabled = False
        btnPesquisar.Enabled = False 'ConvertFlag(Mid(menu.GetBotoesMostrar, 7, 1))
    End Function
    Public Function botoesSalvar()
        btnIncluir.Enabled = False
        btnAlterar.Enabled = False
        btnExcluir.Enabled = False
        btnSalvar.Enabled = ConvertFlag(Mid(menu.GetBotoesSalvar, 4, 1))
        btnCancelar.Enabled = ConvertFlag(Mid(menu.GetBotoesSalvar, 5, 1))
        btnPesquisar.Enabled = False 'ConvertFlag(Mid(menu.GetBotoesSalvar, 7, 1))
    End Function
#End Region
    '----------------------------------------------------------------------
    '   MENU SECUNDARIO
    '----------------------------------------------------------------------
    Sub gotoAcesso(ByVal sender As Object, ByVal e As System.EventArgs)
        Response.Redirect("cadacesso.aspx?")
    End Sub

    Sub gotoPerfil(ByVal sender As Object, ByVal e As System.EventArgs)
        Response.Redirect("cadacessoperfil.aspx?")
    End Sub

    Sub gotoUsuario(ByVal sender As Object, ByVal e As System.EventArgs)
        Response.Redirect("cadacessousuario.aspx?")
    End Sub

    Sub gotoSair(ByVal sender As Object, ByVal e As System.EventArgs)
        Response.Redirect("Principal.aspx?")
    End Sub

    Sub DesabilitaBotoes()
        ' btnAcesso.Enabled = False
        ' btnPerfil.Enabled = False
        ' btnUsuario.Enabled = False
    End Sub

    Sub HabilitaBotoes()
        ' btnAcesso.Enabled = True
        'btnPerfil.Enabled = False
        'btnUsuario.Enabled = True
    End Sub

    '------------------------------------------------------------------------
    '   BOTOES - INCLUSAO, ALTERACAO, EXCLUSAO, PESQUISA, CANCELAR, SAIR
    '------------------------------------------------------------------------
    Sub btnIncluirClick(ByVal obj As Object, ByVal e As System.EventArgs)
        lblstatus.Text = ""
        edtFlagIncAtu.Value = "I"
        DesabilitaBotoes()
        botoesSalvar()
        LimpaTela()
        HabilitaCampos()
        dgConsulta.Enabled = False
        'RotinasDll.SetFocus(edtPerCodigo)
    End Sub

    Sub btnAlterarClick(ByVal obj As Object, ByVal e As System.EventArgs)
        lblstatus.Text = ""
        edtFlagIncAtu.Value = "A"
        botoesSalvar()
        dgConsulta.Enabled = False
        DesabilitaBotoes()
        HabilitaCampos()
        edtPerCodigo.Enabled = False
        '  RotinasDll.SetFocus(edtPerDescricao)
    End Sub

    Sub btnExcluirClick(ByVal obj As Object, ByVal e As System.EventArgs)
        lblstatus.Text = ""
        edtFlagIncAtu.Value = ""
        botoesCadastro()
        ExcluiRegistro()
        CarregaDbgrid()
        LimpaTela()
        DesabilitaCampos()
        HabilitaBotoes()
    End Sub


    Sub btnSalvarClick(ByVal obj As Object, ByVal e As System.EventArgs)
        ValidaCampos()
        If Validacao.Result <> -1 Then
            GravaRegistro()
            LimpaTela()
            CarregaDbgrid()
            botoesCadastro()
            DesabilitaCampos()
            HabilitaBotoes()
            dgConsulta.Enabled = True
        End If
    End Sub

    Sub btnPesquisarClick(ByVal obj As Object, ByVal e As System.EventArgs)
    End Sub

    Sub btnCancelarClick(ByVal obj As Object, ByVal e As System.EventArgs)
        lblstatus.Text = ""
        'campofocus.Text = "btnSair"
        If edtFlagIncAtu.Value = "I" Then
            LimpaTela()
            BotoesMostrar()
        Else
            MostraDados()
            botoesCadastro()
        End If
        webforms.DisableFields(Me)
        HabilitaBotoes()
        dgConsulta.Enabled = True
    End Sub

    '---------------------------------------------------------------------------------
    '   VERIFICA OS DADOS NECESSARIOS PARA UMA INCLUSAO OU ALTERACAO
    '---------------------------------------------------------------------------------
    Sub ValidaCampos()
        Dim mensagem As String = "Ateno! Os campos abaixo so obrigatrios:  \n "
        Validacao.allvalidator(edtPerCodigo.Text, "nulo", "Cdigo", "", mensagem)
        Validacao.allvalidator(edtPerDescricao.Text, "nulo", "Descrio", "finaliza", mensagem)
    End Sub

    '-----------------------------------------------------------------------------------
    '   PROCEDIMENTO DE INCLUSAO E ALTERACAO 
    '-----------------------------------------------------------------------------------
    Sub GravaRegistro()
        RotinasDll.ExecSql("Banco", "stpWebGravaSgPerfil", "StoredProcedure")
        RotinasDll.AddValue("@FlagIncAtu", edtFlagIncAtu.Value, SqlDbType.Char)
        RotinasDll.AddValue("@PerCodigo", edtPerCodigo.Text, SqlDbType.Char)
        RotinasDll.AddValue("@PerDescricao", edtPerDescricao.Text, SqlDbType.Char)
        RotinasDll.AddValue("@NivCodigo", 1, SqlDbType.Int)
        RotinasDll.AddValue("@SnvCodigo", 1, SqlDbType.Int)
        RotinasDll.AddValue("@EstCodigo", 1, SqlDbType.Int)
        Try
            RotinasDll.Comando.Connection.Open()
            RotinasDll.Comando.ExecuteReader()
            If edtFlagIncAtu.Value = "I" Then
                ClientScripts.ClientAlert("O Registro foi Includo com sucesso!")
            Else
                ClientScripts.ClientAlert("O Registro foi Alterado com sucesso!")
            End If
        Catch ex As Exception
            ClientScripts.ClientAlert(ex.Message)
            botoesCadastro()
        End Try

        If CStr(RotinasDll.Comando.Connection.State) = 1 Then 'Open
            RotinasDll.Comando.Connection.Close()
        End If

    End Sub

    '-----------------------------------------------------------------------------
    '   PROCEDIMENTO DE EXCLUSAO
    '-----------------------------------------------------------------------------
    Sub ExcluiRegistro()
        If edtPerCodigo.Text <> "" Then
            RotinasDll.ExecSql("Banco", "stpWebExcluiSgPerfil", "StoredProcedure")
            RotinasDll.AddValue("@PerCodigo", edtPerCodigo.Text, SqlDbType.Char)
            Try
                RotinasDll.Comando.Connection.Open()
                RotinasDll.Comando.ExecuteReader()
                ClientScripts.ClientAlert("O Registro foi Excludo com sucesso!")
            Catch ex As Exception
                ClientScripts.ClientAlert(ex.Message)
                BotoesErro()
            End Try
        Else
            ClientScripts.ClientAlert("Registro no selecionado!")
        End If

        If CStr(RotinasDll.Comando.Connection.State) = 1 Then 'Open
            RotinasDll.Comando.Connection.Close()
        End If

    End Sub

    '--------------------------------------------------------------------------
    '   CARREGA DBGRID 
    '--------------------------------------------------------------------------
    Sub CarregaDbgrid()
        If dgConsulta.Visible = True Then
            'Abre banco, define a STP e passa os parametros
            RotinasDll.ExecSql("Banco", "stpWebMostraSgPerfil", "StoredProcedure")
            RotinasDll.AddValue("@Percodigo", "", SqlDbType.Char)
            Try
                RotinasDll.Comando.Connection.Open()
                dr = RotinasDll.Comando.ExecuteReader
                dgConsulta.DataSource = dr
                dgConsulta.DataBind()
            Catch ex As Exception
                ClientScripts.ClientAlert(ex.Message)
                BotoesErro()
            End Try

            If CStr(RotinasDll.Comando.Connection.State) = 1 Then 'Open
                RotinasDll.Comando.Connection.Close()
            End If
        End If
    End Sub

    '---------------------------------------------------------------------
    '   PREENCHE CAMPOS DA TELA
    '---------------------------------------------------------------------
    Sub MostraDados()
    End Sub

    '-----------------------------------------------------------------------------------
    '   PREENCHIMENTO DO LISTBOX NO LOAD DA PAGINA
    '-----------------------------------------------------------------------------------
    Sub PreencheListBox()
    End Sub

    '-----------------------------------------------------------------------------------
    '   PREENCHE CAMPOS A PARTIR DO SELECINADO NO GRID
    '-----------------------------------------------------------------------------------
    Sub RetornaDados(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs)
        lblstatus.Text = ""
        edtPerCodigo.Text = RTrim(e.Item.Cells(1).Text & " ")
        edtPerDescricao.Text = RTrim(e.Item.Cells(2).Text & " ")
        BotoesMostrar()
    End Sub

    '-----------------------------------------------------------------------------------
    '   LIMPA TELA
    '-----------------------------------------------------------------------------------
    Sub LimpaTela()
        edtPerCodigo.Text = ""
        edtPerDescricao.Text = ""
    End Sub

    Sub HabilitaCampos()
        edtPerCodigo.Enabled = True
        edtPerDescricao.Enabled = True
    End Sub

    Sub DesabilitaCampos()
        edtPerCodigo.Enabled = False
        edtPerDescricao.Enabled = False
    End Sub

    '-----------------------------------------------------------------------------------
    '  MOSTRA/OCULTA O DATAGRID QDO SELECIONADO NO LINKBUTTON
    '-----------------------------------------------------------------------------------
    Sub HabilitaGrid(ByVal obj As Object, ByVal e As System.EventArgs)
        If edtPerDescricao.Enabled = False Then
            If dgConsulta.Visible = False Then
                dgConsulta.Visible = True
                lnkDgConsulta.Text = "Ocultar Relao de Perfis"
                CarregaDbgrid()
            Else
                dgConsulta.Visible = False
                lnkDgConsulta.Text = "Exibir Relao de Perfis"
            End If
        End If
    End Sub

End Class
