Public Class CadAcessoUsuario
    Inherits System.Web.UI.Page

#Region " Web Form Designer Generated Code "

    'This call is required by the Web Form Designer.
    <System.Diagnostics.DebuggerStepThrough()> Private Sub InitializeComponent()

    End Sub
    'Classes Utilizadas
    Public webforms As New webforms
    Public RotinasDll As New Rotinas
    Public dr As System.Data.SqlClient.SqlDataReader
    Public alertas As New Alerta
    Public ClientScripts As New ClientScripts
    Public menu As New menu
    Public Validacao As New Validate
    Public util As New Utilitario
    Public xmlfile As New xmlfile

    'Declaracao dos Botoes
    Public btnPesquisar As System.web.ui.webcontrols.Button
    Public btnIncluir As System.web.ui.webcontrols.Button
    Public btnExcluir As System.web.ui.webcontrols.Button
    Public btnAlterar As System.web.ui.webcontrols.Button
    Public btnSalvar As System.web.ui.webcontrols.Button
    Public btnCancelar As System.web.ui.webcontrols.Button

    'Menu
    Public btnAcesso As System.web.ui.webcontrols.Button
    Public btnPerfil As System.web.ui.webcontrols.Button
    Public btnUsuario As System.web.ui.webcontrols.Button

    Protected WithEvents lblstatus As System.Web.UI.WebControls.Label
    Protected WithEvents pnlCadastro As System.Web.UI.WebControls.Panel
    Protected WithEvents edtFlagIncAtu As System.Web.UI.HtmlControls.HtmlInputHidden
    Protected WithEvents lblTitulo As System.Web.UI.WebControls.Label
    Protected WithEvents lblUsuNome As System.Web.UI.WebControls.Label
    Protected WithEvents edtUsuNome As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblUsuLogin As System.Web.UI.WebControls.Label
    Protected WithEvents edtUsuLogin As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblNewSenha As System.Web.UI.WebControls.Label
    Protected WithEvents edtNewSenha As System.Web.UI.WebControls.TextBox
    Protected WithEvents lblPerCodigo As System.Web.UI.WebControls.Label
    Protected WithEvents lstPerCodigo As System.Web.UI.WebControls.DropDownList
    Protected WithEvents lnkDgConsulta As System.Web.UI.WebControls.LinkButton
    Protected WithEvents dgConsulta As System.Web.UI.WebControls.DataGrid
    Protected WithEvents PanelGrid As System.Web.UI.WebControls.Panel
    Protected WithEvents edtususenha As System.Web.UI.HtmlControls.HtmlInputHidden
    Protected WithEvents edtvarusucodusuario As System.Web.UI.HtmlControls.HtmlInputHidden

    'NOTE: The following placeholder declaration is required by the Web Form Designer.
    'Do not delete or move it.
    Private designerPlaceholderDeclaration As System.Object

    Private Sub Page_Init(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Init
        'CODEGEN: This method call is required by the Web Form Designer
        'Do not modify it using the code editor.
        InitializeComponent()
    End Sub

#End Region


#Region " LOAD DA PAGINA"
    '------------------------------------------------------------------------
    '   LOAD DA PAGINA
    '------------------------------------------------------------------------
    Private Sub Page_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        If Not IsPostBack() Then
            botoesCadastro()
            MenuSecundario_Liberado()
            webforms.DisableFields(Me)
            PreencheList()
            dgConsulta.Visible = False
            'CarregaDbGrid()
        End If
        ClientScripts.ConfirmarExclusao(btnExcluir, "CONFIRMA EXCLUSO DO REGISTRO ?")
    End Sub
#End Region

#Region "VALIDACAO DOS BOTOES CONFORME PERMISSAO DO USUARIO"
    '------------------------------------------------------------------------
    '  VALIDACAO DOS BOTOES CONFORME PERMISSAO DO USUARIO
    '------------------------------------------------------------------------
    Public Function ConvertFlag(ByVal flag)
        If UCase(flag) = "F" Then
            Return False
        Else
            Return True
        End If
    End Function

    Public Function botoesCadastro()
        btnIncluir.Enabled = ConvertFlag(Mid(menu.GetBotoesCadastro, 1, 1))
        btnAlterar.Enabled = False
        btnExcluir.Enabled = False
        btnSalvar.Enabled = False
        btnCancelar.Enabled = False
        btnPesquisar.Enabled = False 'ConvertFlag(Mid(menu.GetBotoesCadastro, 7, 1))
    End Function
    Public Function BotoesErro()
        btnIncluir.Enabled = False
        btnAlterar.Enabled = False
        btnExcluir.Enabled = False
        btnSalvar.Enabled = False
        btnCancelar.Enabled = False
        btnPesquisar.Enabled = False
    End Function
    Public Function BotoesAlterar()
        btnIncluir.Enabled = False
        btnAlterar.Enabled = False
        btnExcluir.Enabled = False
        btnSalvar.Enabled = False
        btnCancelar.Enabled = False
        btnPesquisar.Enabled = False
    End Function
    Public Function BotoesMostrar()
        btnIncluir.Enabled = ConvertFlag(Mid(menu.GetBotoesMostrar, 1, 1))
        btnAlterar.Enabled = ConvertFlag(Mid(menu.GetBotoesMostrar, 2, 1))
        btnExcluir.Enabled = ConvertFlag(Mid(menu.GetBotoesMostrar, 3, 1))
        btnSalvar.Enabled = False
        btnCancelar.Enabled = False
        btnPesquisar.Enabled = False 'ConvertFlag(Mid(menu.GetBotoesMostrar, 7, 1))
    End Function
    Public Function botoesSalvar()
        btnIncluir.Enabled = False
        btnAlterar.Enabled = False
        btnExcluir.Enabled = False
        btnSalvar.Enabled = ConvertFlag(Mid(menu.GetBotoesSalvar, 4, 1))
        btnCancelar.Enabled = ConvertFlag(Mid(menu.GetBotoesSalvar, 5, 1))
        btnPesquisar.Enabled = False 'ConvertFlag(Mid(menu.GetBotoesSalvar, 7, 1))
    End Function
#End Region

#Region "MENU SECUNDARIO"
    '----------------------------------------------------------------------
    '   MENU SECUNDARIO
    '----------------------------------------------------------------------
    Sub gotoAcesso(ByVal sender As Object, ByVal e As System.EventArgs)
        Response.Redirect("CadAcesso.aspx?")
    End Sub

    Sub gotoPerfil(ByVal sender As Object, ByVal e As System.EventArgs)
        Response.Redirect("CadAcessoPerfil.aspx?")
    End Sub

    Sub gotoUsuario(ByVal sender As Object, ByVal e As System.EventArgs)
        Response.Redirect("CadAcessoUsuario.aspx?")
    End Sub
    Sub gotoSair(ByVal sender As Object, ByVal e As System.EventArgs)
        Response.Redirect("Principal.aspx?")
    End Sub

    Sub MenuSecundario_Cadastro()
        'btnAcesso.Enabled = False
        'btnPerfil.Enabled = False
        'btnUsuario.Enabled = False
    End Sub

    Sub MenuSecundario_Liberado()
        ' btnAcesso.Enabled = True
        ' btnPerfil.Enabled = True
        ' btnUsuario.Enabled = False
    End Sub

#End Region

#Region "BOTOES - INCLUSAO, ALTERACAO, EXCLUSAO, PESQUISA, CANCELAR, SAIR"
    '------------------------------------------------------------------------
    '   BOTOES - INCLUSAO, ALTERACAO, EXCLUSAO, PESQUISA, CANCELAR, SAIR
    '------------------------------------------------------------------------
    Sub btnIncluirClick(ByVal obj As Object, ByVal e As System.EventArgs)
        lblstatus.Text = ""
        edtFlagIncAtu.Value = "I"
        MenuSecundario_Cadastro()
        botoesSalvar()
        LimpaTela()
        webforms.EnabledFields(Me)
        dgConsulta.Enabled = False
        'campofocus.Text = "edtusunome"
    End Sub

    Sub btnAlterarClick(ByVal obj As Object, ByVal e As System.EventArgs)
        lblstatus.Text = ""
        edtFlagIncAtu.Value = "A"
        botoesSalvar()
        dgConsulta.Enabled = False
        MenuSecundario_Cadastro()
        webforms.EnabledFields(Me)
        '  campofocus.Text = "edtusunome"
        edtUsuLogin.Enabled = False

    End Sub

    Sub btnExcluirClick(ByVal obj As Object, ByVal e As System.EventArgs)

        ExcluiRegistro()
        webforms.ClearFields(Me)
        webforms.DisableFields(Me)
        webforms.DisableDropDownlist(Me)
        botoesCadastro()
        'lblStatus.Text = "Usurio Excluido do Sistema com Sucesso !!"
        ClientScripts.ClientAlert("Usurio Excluido do Sistema com Sucesso !!")

    End Sub


    Sub btnSalvarClick(ByVal obj As Object, ByVal e As System.EventArgs)
        ValidaCampos()
        If Validacao.Result <> -1 Then
            GravaRegistro()
            CarregaDbgrid()
            botoesCadastro()
            'campofocus.Text = "btnSair"
            webforms.DisableFields(Me)
            MenuSecundario_Liberado()
            '            dgConsulta.Enabled = True
        End If
    End Sub

    Sub btnPesquisarClick(ByVal obj As Object, ByVal e As System.EventArgs)
    End Sub

    Sub btnCancelarClick(ByVal obj As Object, ByVal e As System.EventArgs)
        'if pnlsgusuario.Visible = true
        'pnlsgusuario.Visible = False
        'else
        '   pnlsgusuario.Visible = true
        'end if
        edtFlagIncAtu.Value = ""
        lblstatus.Text = ""
        'campofocus.Text = "btnSair"
        LimpaTela()
        botoesCadastro()
        webforms.DisableFields(Me)
        MenuSecundario_Liberado()
        dgConsulta.Enabled = True
    End Sub

#End Region

#Region "ValidaCampos"
    '---------------------------------------------------------------------------------
    '   VERIFICA OS DADOS NECESSARIOS PARA UMA INCLUSAO OU ALTERACAO
    '---------------------------------------------------------------------------------
    Sub ValidaCampos()
        Dim mensagem As String = "Ateno! Os campos abaixo so obrigatrios:  \n "
        Validacao.allvalidator(edtUsuLogin.Text, "nulo", "Cdigo", "", mensagem)
        Validacao.allvalidator(edtUsuNome.Text, "nulo", "Nome", "", mensagem)
        Validacao.allvalidator(lstPerCodigo.SelectedItem.Value, "nulo", "Perfil", "finaliza", mensagem)

    End Sub
#End Region

#Region "VALIDAR SE LOGIN J EXISTE "


    Sub verifica_login()
        Dim INST_SQL
        INST_SQL = "select  count(usulogin) as contador from sgusuario where usulogin='" & LTrim(RTrim(edtUsuLogin.Text)) & "'"
        RotinasDll.ExecSql("Banco", INST_SQL, "text")
        Try
            RotinasDll.Comando.Connection.Open()
            dr = RotinasDll.Comando.ExecuteReader
            If dr.Read() Then
                If Validacao.nulo(dr.Item("contador"), 0) <> 0 Then
                    'lblStatus.Text = "Login de usurio '" & LTrim(RTrim(edtusucodusuario.Text)) & "' j cadastrado no sistema ! Informe outro !"
                    ClientScripts.ClientAlert("Login de usurio '" & LTrim(RTrim(edtUsuLogin.Text)) & "' j cadastrado no sistema ! Informe outro !")
                    edtUsuLogin.Text = ""
                    'campofocus.Text = "edtusucodusuario"
                Else
                    'campofocus.Text = "edtnewsenha"
                End If
            End If
            RotinasDll.Comando.Connection.Close()
        Catch ex As Exception
            'Mensagem Erro
            'lblStatus.Text = ex.Message & "PROBLEMA NA SUB PARA VALIDAR LOGIN"
            ClientScripts.ClientAlert("Problema na validao do login")
            BotoesErro()
        End Try
    End Sub
#End Region

#Region "PROCEDIMENTO DE INCLUSAO E ALTERACAO "
    Sub GravaRegistro()
        RotinasDll.ExecSql("Banco", "stpWebGravaSgUsuario", "StoredProcedure")
        RotinasDll.AddValue("@FlagIncAtu", edtFlagIncAtu.Value, SqlDbType.Char)
        RotinasDll.AddValue("@UsuLogin", edtUsuLogin.Text, SqlDbType.Char)
        RotinasDll.AddValue("@UsuNome", edtUsuNome.Text, SqlDbType.Char)
        If edtNewSenha.Text = "" Then
            RotinasDll.AddValue("@UsuSenha", edtususenha.Value, SqlDbType.Char)
        Else
            RotinasDll.AddValue("@UsuSenha", edtNewSenha.Text, SqlDbType.Char)
        End If
        RotinasDll.AddValue("@Percodigo", lstPerCodigo.SelectedItem.Value, SqlDbType.Char)
        Try
            RotinasDll.Comando.Connection.Open()
            RotinasDll.Comando.ExecuteReader()
            If edtFlagIncAtu.Value = "I" Then
                ClientScripts.ClientAlert("O Registro foi Includo com sucesso!")
                'lblStatus.Text = "Novo login criado com sucesso !"
                'ClientScripts.ClientAlert("Novo login criado com sucesso!")
            Else ' CASO ALTERACAO = DELETE DO SQL SERVER , E CRIA NOVAMENTE
                ClientScripts.ClientAlert("O Registro foi Alterado com sucesso!")
                'Deleta_Usuario_no_banco() 'edtvarusucodusuario.Text
                'Cria_Usuario_no_banco()
                'lblStatus.Text = "Informaes do Usurio alteradas com sucesso"
                If UCase(RTrim(util.PegarParametro(Context.User.Identity.Name, 2))) = UCase(RTrim(edtUsuLogin.Text)) Then
                    'ClientScripts.ClientAlert("alterou cookie")
                    'CriarTicket()
                End If
                ClientScripts.ClientAlert("Informaes do Usurio Alteradas com sucesso!")
            End If
        Catch ex As Exception
            ClientScripts.ClientAlert(ex.Message)
            botoesCadastro()
        End Try

        If CStr(RotinasDll.Comando.Connection.State) = 1 Then 'Open
            RotinasDll.Comando.Connection.Close()
        End If

        LimpaTela()
        CarregaDbgrid()
        botoesCadastro()

        webforms.DisableFields(Me)
        MenuSecundario_Liberado()
        dgConsulta.Enabled = True
        'pnlsgusuario.Visible = False
        'campofocus.Text = "btnSair"
    End Sub

#End Region

#Region "PROCEDIMENTO DE EXCLUSAO"
    Sub ExcluiRegistro()
        If edtUsuLogin.Text <> "" Then
            RotinasDll.ExecSql("Banco", "stpWebExcluiSgUsuario", "StoredProcedure")
            RotinasDll.AddValue("@UsuLogin", edtUsuLogin.Text, SqlDbType.Char)
            Try
                RotinasDll.Comando.Connection.Open()
                RotinasDll.Comando.ExecuteReader()
                ClientScripts.ClientAlert("O Registro foi Excludo com sucesso!")
            Catch ex As Exception
                ClientScripts.ClientAlert(ex.Message)
                BotoesErro()
            End Try
        Else
            ClientScripts.ClientAlert("Registro no selecionado!")
        End If

        If CStr(RotinasDll.Comando.Connection.State) = 1 Then 'Open
            RotinasDll.Comando.Connection.Close()
        End If

        botoesCadastro()
        CarregaDbgrid()
        LimpaTela()
        webforms.DisableFields(Me)
        MenuSecundario_Liberado()
        'pnlsgusuario.Visible = False
        'campofocus.Text = "btnSair"

    End Sub
#End Region

#Region " CARREGA DBGRID "
    '--------------------------------------------------------------------------
    '   CARREGA DBGRID 
    '--------------------------------------------------------------------------
    Sub CarregaDbgrid()
        If dgConsulta.Visible = True Then
            'Abre banco, define a STP e passa os parametros
            RotinasDll.ExecSql("Banco", "stpWebMostraSgUsuario", "StoredProcedure")
            RotinasDll.AddValue("@UsuLogin", Replace(util.PegarParametro(Context.User.Identity.Name, 1), "'", " "), SqlDbType.Char)
            Try
                RotinasDll.Comando.Connection.Open()
                dr = RotinasDll.Comando.ExecuteReader
                dgConsulta.DataSource = dr
                dgConsulta.DataBind()
            Catch ex As Exception
                ClientScripts.ClientAlert(ex.Message)
                BotoesErro()
            End Try

            If CStr(RotinasDll.Comando.Connection.State) = 1 Then 'Open
                RotinasDll.Comando.Connection.Close()
            End If
        End If
    End Sub
#End Region

#Region " PREENCHE CAMPOS DA TELA"
    '---------------------------------------------------------------------
    '   PREENCHE CAMPOS DA TELA
    '---------------------------------------------------------------------
    Sub MostraDados()
    End Sub
#End Region

#Region " PREENCHIMENTO DO LISTBOX NO LOAD DA PAGINA"
    '-----------------------------------------------------------------------------------
    '   PREENCHIMENTO DO LISTBOX NO LOAD DA PAGINA
    '-----------------------------------------------------------------------------------
    Sub PreencheList()
        'Dim ds As New DataSet
        'ds.ReadXml(ConfigurationSettings.AppSettings("XMLFile") & "XMLOUTROS.xml")

        'xmlfile.preenchedrop(lstPerCodigo, ds)

        RotinasDll.ShowList("select perdescricao, percodigo from sgperfil order by perdescricao", "Banco", lstPerCodigo, "perdescricao", "percodigo")
        lstPerCodigo.Items.Add(" ")
        webforms.SelectListValue(lstPerCodigo, " ", "text")
    End Sub
#End Region

#Region " PREENCHE CAMPOS A PARTIR DO SELECINADO NO GRID"
    '-----------------------------------------------------------------------------------
    '   PREENCHE CAMPOS A PARTIR DO SELECINADO NO GRID
    '-----------------------------------------------------------------------------------
    Sub RetornaDados(ByVal source As Object, ByVal e As System.Web.UI.WebControls.DataGridCommandEventArgs)
        lblstatus.Text = ""
        edtvarusucodusuario.Value = RTrim(e.Item.Cells(1).Text & " ") ' utilizada para caso de exclusao , saber realmente qual usuario excluir
        edtUsuLogin.Text = RTrim(e.Item.Cells(1).Text & " ")
        edtUsuNome.Text = RTrim(e.Item.Cells(2).Text & " ")
        edtususenha.Value = RTrim(e.Item.Cells(3).Text & " ")
        webforms.SelectListValue(lstPerCodigo, RTrim(e.Item.Cells(4).Text & " "), "text")
        BotoesMostrar()
    End Sub

    '-----------------------------------------------------------------------------------
    '   LIMPA TELA
    '-----------------------------------------------------------------------------------
    Sub LimpaTela()
        edtUsuLogin.Text = ""
        edtUsuNome.Text = ""
        edtususenha.Value = ""
        webforms.SelectListValue(lstPerCodigo, " ", "text")
    End Sub
#End Region

#Region "MOSTRA/OCULTA O DATAGRID QDO SELECIONADO NO LINKBUTTON"
    '-----------------------------------------------------------------------------------
    '  MOSTRA/OCULTA O DATAGRID QDO SELECIONADO NO LINKBUTTON
    '-----------------------------------------------------------------------------------
    Sub HabilitaGrid(ByVal obj As Object, ByVal e As System.EventArgs)
        If lstPerCodigo.Enabled = False Then
            If dgConsulta.Visible = False Then
                dgConsulta.Visible = True
                lnkDgConsulta.Text = "Ocultar Relao de Usurios"
                CarregaDbgrid()
            Else
                dgConsulta.Visible = False
                lnkDgConsulta.Text = "Exibir Relao de Usurios"
            End If
        End If
    End Sub

#End Region

    Private Sub edtUsuLogin_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles edtUsuLogin.TextChanged
        verifica_login()
    End Sub

End Class
